// Generated by CoffeeScript 1.8.0
(function() {
  var Context, async, call, colors, generator, lift, promise, _ref;

  colors = require("colors");

  _ref = require("when"), promise = _ref.promise, lift = _ref.lift;

  generator = require("when/generator");

  async = generator.lift;

  call = generator.call;

  Context = (function() {
    Context.describe = function(description, fn) {
      return (new Context(description))._run(fn);
    };

    function Context(description, parent) {
      var _ref1, _ref2;
      this.description = description;
      this.parent = parent;
      if ((_ref1 = this.parent) != null) {
        _ref1.kids.push(this);
      }
      this.kids = [];
      this.root = ((_ref2 = this.parent) != null ? _ref2.root : void 0) || this;
    }

    Context.prototype._run = function(fn) {
      return call((function(_this) {
        return function*() {
          _this.pending = 0;
          _this.resolve = null;
          fn(_this);
          (yield _this.wait());
          return _this.report();
        };
      })(this));
    };

    Context.prototype.wait = function() {
      return promise((function(_this) {
        return function(resolve) {
          _this.resolve = resolve;
          if (!(_this.pending > 0)) {
            return _this.resolve();
          }
        };
      })(this));
    };

    Context.prototype.start = function() {
      return ++this.pending;
    };

    Context.prototype.finish = function() {
      if (--this.pending === 0) {
        return this.resolve();
      }
    };

    Context.prototype.describe = function(description, fn) {
      return fn(new Context(description, this));
    };

    Context.prototype.test = function(description, fn) {
      return (new Context(description, this)).run(fn);
    };

    Context.prototype.run = function(fn) {
      var error;
      if (fn != null) {
        if (fn.constructor.name === "GeneratorFunction") {
          return call((function(_this) {
            return function*() {
              var error;
              _this.root.start();
              try {
                (yield (call(fn, _this)));
                _this.pass();
              } catch (_error) {
                error = _error;
                _this.fail(error);
              }
              return _this.root.finish();
            };
          })(this));
        } else {
          try {
            fn(this);
            return this.pass();
          } catch (_error) {
            error = _error;
            return this.fail(error);
          }
        }
      } else {
        return this.fail();
      }
    };

    Context.prototype.pass = function() {
      return this.result != null ? this.result : this.result = true;
    };

    Context.prototype.fail = function(error) {
      if ((error != null ? error.stack : void 0) != null) {
        console.error(error.stack);
      }
      this.result = false;
      return this.error = error;
    };

    Context.prototype.report = function(indent) {
      var kid, _i, _len, _ref1, _results;
      if (indent == null) {
        indent = "";
      }
      console.log(indent, this.result != null ? this.error != null ? ("" + this.description + " [" + this.error + "]").red : this.result ? this.description.green : this.description.yellow : this.description.bold.green);
      _ref1 = this.kids;
      _results = [];
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        kid = _ref1[_i];
        _results.push(kid.report(indent + "  "));
      }
      return _results;
    };

    return Context;

  })();

  module.exports = Context;

}).call(this);
